float4x4 mWVP;
texture MatTexture;
float4 EyeVec;

sampler Samp = sampler_state
{
	Texture = <MatTexture>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	//AddressU = Clamp;
	//AddressV = Clamp;
};

struct VS_OUTPUT
{
	float4 Pos		:	POSITION;
	float4 Col		:	COLOR;
	float2 Tex		:	TEXCOORD0;
	float3 Nrm		:	TEXCOORD1;
	float3 Eye		:	TEXCOORD2;
};

VS_OUTPUT VS(
	float4 Pos		:	POSITION,
	float3 Nor		:	NORMAL,
	float2 Tex		:	TEXCOORD
){
	VS_OUTPUT Out =  (VS_OUTPUT) 0;
	Out.Pos = mul(Pos,mWVP);
	Out.Tex = Tex;
	Out.Nrm = Nor;
	Out.Eye = normalize(EyeVec - Pos.xyz);
	return Out;
}

float4 PS( VS_OUTPUT In) : COLOR
{
	float3 amb = {0.15f,0.15f,0.15f};
	float3 L = {-0.2f, -0.6f, -0.2f};
	float3 H = normalize(L + In.Eye);
	float R  = -In.Eye + 2.0f*dot(In.Nrm,In.Eye)*In.Nrm;
	float4 cl = tex2D(Samp, In.Tex);
	cl.rgb = cl.rgb * cl.rgb * (max(dot(In.Nrm,L),0) + amb) + pow(max(dot(L,R),0),10) + pow(max(dot(In.Nrm,H),0),5);
	cl.a = tex2D(Samp, In.Tex).a;
	return cl;
}

technique TShader
{
	pass P0
	{
		VertexShader = compile vs_1_1 VS();
		PixelShader = compile ps_2_0 PS();
	}
}